#include <cstdio>
#include <cstring> // memset

#include "nes.hh"

#include "mappers.cc"

bisqnes nes;

void Wr6502(register fWORD Addr, register fBYTE Value)
{
    nes.Wr(Addr, Value);
}
BYTE Rd6502(register fWORD Addr)
{
    return nes.Rd(Addr);
}
BYTE Op6502(register fWORD Addr)
{
    return nes.Op(Addr);
}


int main(int argc, const char *const *argv)
{
    if(argc <= 1)
    {
        fprintf(stderr,
             "A NES emulator written by Bisqwit (http://iki.fi/bisqwit/)\n"
             "Version "VERSION"\n"
             "\n"
             "Usage: nes <cart.nes> [<cart.sta>]\n"
             "\n");
        return -1;
    }
    nes.load(argv[1]);
    if(argc > 2)nes.sta_load(argv[2]);
    nes.run();
    return 0;
}
