#include "system.hh"
#include <unistd.h>
#include <string.h>

Audio::Audio()
{
	fd = 1;
	_hz = 44100;
	_stereo = false;
	_bits = 16;
}
Audio::~Audio()
{
}
void Audio::Write(BYTE value)
{
	std::write(fd, &value, 1);
}
void Audio::Write(BYTE value, unsigned count)
{
	BYTE buf[count];
	memset(buf, value, count);
	std::write(fd, buf, sizeof buf);
}
void Audio::Write(BYTE left, BYTE right)
{
	std::write(fd, &left, 1);
	std::write(fd, &right, 1);
}
void Audio::Write(BYTE left, BYTE right, unsigned count)
{
	register unsigned max = count*2;
	BYTE buf[max];
	for(unsigned a=0; a<max; )
	{
		buf[a++] = left;
		buf[a++] = right;
	}
	std::write(fd, buf, sizeof buf);
}
void Audio::Write(SWORD value)
{
	std::write(fd, &value, 2);
}
void Audio::Write(SWORD value, unsigned count)
{
	SWORD buf[count];
	for(unsigned a=0; a<count; ++a)
		buf[a] = value;
	
	std::write(fd, &buf, sizeof buf);
}
void Audio::Write(SWORD left, SWORD right)
{
	std::write(fd, &left, 2);
	std::write(fd, &right, 2);
}
void Audio::Write(SWORD left, SWORD right, unsigned count)
{
	register unsigned max = count*2;
	SWORD buf[max];
	for(unsigned a=0; a<max; )
	{
		buf[a++] = left;
		buf[a++] = right;
	}
	std::write(fd, buf, sizeof buf);
}

Audio AudioSystem;

#if 0
void Video::Video()
{
	GenPal(332, 0.5);
}
void Video::~Video()
{
}

// hue: 12=tysi ympyr, tint = 0-1
void Video::GenPal(double hue, double tint)
{
	// Thanks to Kevin Horton, as this algorithm is his.
	
	static const BYTE cols[16] = {0,8,7,6, 5,4,3,2, 1,0,11,10, 9,0,0,0};
	
	static const BYTE br1[4] = {50, 75,100,100};
	static const BYTE br2[4] = {29, 45, 73, 90};
	static const BYTE br3[4] = {0,  24, 47, 77};
	
	fWORD ind = 0;
	for(BYTE x=0; x<4; ++x)
		for(BYTE z=0; z<16; ++z)
		{
			unsigned y;
			double s;
			if(z==0)      s = 0, y = br1[x];    // XDh? get luma.
			else if(z==13)s = 0, y = br3[x];    // X0h? get luma.
			else if(z==14)y = 0, s = 0;         // XEh? black.
			else if(z==15)y = 0, s = 0;         // XFh? black.
			else s = tint, y = br2[x];
			
			double theta = 3.14159265358979323844 * (cols[z] + hue) / 6;
			
			// 3.14159 265 3 58 97 93 23844
			
			const double st = s * sin(theta);
			const double ct = s * cos(theta);
			
			const double r = 2.56 * (y + st*100);
			const double g = 2.56 * (y - st * (2700/53.0)
			                           + ct * (1000/53.0));
			const double b = 2.56 * (y - ct*100);
			
			palette[ind].r = (r < 0) ? 0: (r > 255) : 255 : r;
			palette[ind].g = (g < 0) ? 0: (g > 255) : 255 : g;
			palette[ind].b = (b < 0) ? 0: (b > 255) : 255 : b;
			++ind;
		}
}
#endif
